<script setup>
import { date_manager } from "~/adapters/date_manager.js";

const emit = defineEmits(['blur']);

const props = defineProps({
  is_multiple: {
    type: Boolean,
    required: true,
  },
  button_id: {
    type: String,
    required: true,
  },

  use_mandatory: {
    type: Boolean,
    default: true
  },
  start_date_extend_class: {
    type: String,
    default: ""
  },
  start_hour_extend_class: {
    type: String,
    default: ""
  },
  end_date_extend_class: {
    type: String,
    default: ""
  },
  end_hour_extend_class: {
    type: String,
    default: ""
  }
});

const dropdowns = reactive({
  1: {
    name: "locations",
    isOn: false,
  },
  2: {
    name: "prices",
    isOn: false,
  },
  3: {
    name: "repeat",
    isOn: false,
  },
});
const incorrectDateVisibility = ref ("invisible");
const dateIncorrectClass = computed (()=>{
  return "absolute top-0 left-0 flex items-center h-full rounded-lg bg-white opacity-90 text-center text-xl text-las-orange font-bold italic "+getClassWarning ()+ " " + incorrectDateVisibility.value;
});

function onBlur (evt) {
  emit ("blur",evt);
}

function manageDropdownDisplay(index) {
  const div_form = document.getElementById("dropdown_" + dropdowns[index].name);
  const div_class = "absolute block z-10";
  if (dropdowns[index].isOn) {
    div_form.setAttribute(
      "class",
      div_form.getAttribute("class").replace("hidden", div_class)
    );
  } else {
    div_form.setAttribute(
      "class",
      div_form.getAttribute("class").replace(div_class, "hidden")
    );
  }
}

function toggleDropdown(index) {
  dropdowns[index].isOn = !dropdowns[index].isOn;
  manageDropdownDisplay(index);
}

function closeDropdown(index) {
  dropdowns[index].isOn = false;
  manageDropdownDisplay(index);
}

function toggleDiv(id, isOn) {
  const div = document.getElementById(id);
  if (isOn) {
    div.setAttribute("class", div.getAttribute("class").replace("hidden", ""));
  } else {
    div.setAttribute("class", div.getAttribute("class") + " hidden");
  }
}

// LOCATION functions
function removeLocation() {
  date_manager.removeLocation();
}

// PRICES functions
function removePrice(price_uid) {
  date_manager.getActiveDate().price_manager.remove(price_uid);
}

// DATES functions
function setStartDate(start_date) {
  date_manager.getActiveDate().setStartDate(start_date);
  if (date_manager.getActiveEndDate() == null) {
    date_manager.getActiveDate().setEndDate(start_date);
  }
}

// gestion de la dialog d'alert d'un ensemble de date invalide
function controlIntegriteDate () {
  if (date_manager.getActiveDate().start_date!=null
        && date_manager.getActiveDate().end_date!=null
        && date_manager.getActiveDate().start_hour!=null
        && date_manager.getActiveDate().end_hour!=null) {
    if (new Date (date_manager.getActiveDate().start_date+"T"+date_manager.getActiveDate().start_hour)>new Date (date_manager.getActiveDate().end_date+"T"+date_manager.getActiveDate().end_hour)) {
      incorrectDateShow ();
    }
  }
}

function incorrectDateHidden () {
  incorrectDateVisibility.value="invisible";
}

function incorrectDateShow () {
  incorrectDateVisibility.value="";
  setTimeout(function() {
    incorrectDateVisibility.value="invisible";
  }, 2000);
}
</script>

<template>
  <div class="w-[649px] flex flex-col space-y-2">
    <FormInput
      v-if="is_multiple"
      :id="'input_date_name'"
      :is_mandatory="is_multiple"
      :button_id="button_id"
      :text="'Titre du sous-évènement'"
      :maxlength="'256'"
      :details="'placeholder:text-center'"
      @value="(value) => date_manager.getActiveDate().setName(value)"
      :value="date_manager.getActiveDate().name"
    />
    <FormInput
      v-if="is_multiple"
      :type="'textarea'"
      :id="'input_date_description'"
      :is_mandatory="is_multiple"
      :button_id="button_id"
      :text="'Description du sous-évènement'"
      :maxlength="'1024'"
      @value="(value) => date_manager.getActiveDate().setDescription(value)"
      :value="date_manager.getActiveDate().description"
      :details="'h-[200px]'"
    />
    <div class="flex flex-row space-x-7">
      <div class="w-[297px] flex flex-col space-y-2">
        <div id="form_locations" class="relative">
          <FormDropSection
            id="d_locations"
            @click="toggleDropdown(1)"
            :section-title="'Lieu'"
            :section-is-on="dropdowns[1].isOn"
          />
          <FormLocations
            id="dropdown_locations"
            @close="closeDropdown(1)"
            class="hidden"
          />
        </div>
        <ButtonRemovable
          v-if="date_manager.getActiveDate().location != null"
          v-bind="date_manager.getActiveDate().location"
          @remove="removeLocation"
          class="mt-2"
        />
        <div class="flex flex-col space-y-2">
          <div id="form_prices" class="relative">
            <FormDropSection
              id="d_prices"
              @click="toggleDropdown(2)"
              :section-title="'Tarifs'"
              :section-is-on="dropdowns[2].isOn"
            />
            <FormPrices
              id="dropdown_prices"
              @close="closeDropdown(2)"
              class="hidden"
            />
          </div>
          <ButtonRemovable
            v-for="price in date_manager
              .getActiveDate()
              .price_manager.getList()"
            :name="price.displayText()"
            :uid="price.uid"
            @remove="(uid) => removePrice(uid)"
            class="mt-2"
          />
        </div>
      </div>
      <div>
        <div class="w-[319px] flex flex-col space-y-2">
          <div class="relative flex flex-col" >
            <div class="flex justify-around">
              <div class="flex flex-col space-y-2 items-center">
                <span>début</span>
                <FormInput
                  :type="'date'"
                  :id="'input_date_start_date'"
                  :is_mandatory="use_mandatory"
                  :button_id="button_id"
                  @value="(value) => {setStartDate(value);controlIntegriteDate ()}"
                  :value="date_manager.getActiveDate().start_date"
                  :extend_class="`${start_date_extend_class}`"
                  @blur="onBlur('start_date')"
                />
                <FormInput
                  :type="'time'"
                  :id="'input_date_start_hour'"
                  :is_mandatory="use_mandatory"
                  :button_id="button_id"
                  @value="(value) => {date_manager.getActiveDate().setStartHour(value);controlIntegriteDate ()}"
                  :value="date_manager.getActiveDate().start_hour"
                  :extend_class="`${start_hour_extend_class}`"
                  @blur="onBlur('start_hour')"
                />
              </div>
              <div class="flex flex-col space-y-2 items-center">
                <span>fin</span>
                <FormInput
                  :type="'date'"
                  :id="'input_date_end_date'"
                  :is_mandatory="use_mandatory"
                  :button_id="button_id"
                  @value="(value) => {date_manager.getActiveDate().setEndDate(value);controlIntegriteDate ()}"
                  :value="date_manager.getActiveDate().end_date"
                  :extend_class="`${end_date_extend_class}`"
                  @blur="onBlur('end_date')"
                />
                <FormInput
                  :type="'time'"
                  :id="'input_date_end_hour'"
                  :is_mandatory="use_mandatory"
                  :button_id="button_id"
                  @value="(value) => {date_manager.getActiveDate().setEndHour(value);controlIntegriteDate ()}"
                  :value="date_manager.getActiveDate().end_hour"
                  :extend_class="`${end_hour_extend_class}`"
                  @blur="onBlur('end_hour')"
                />
              </div>
            </div>
          <div id="dateIncorrectDialog" :class="dateIncorrectClass" @click="incorrectDateHidden ()">La fin de l'évènement est programmée avant le début.</div>
        </div>

          <FormCheckbox
            @checked="(checked) => toggleDiv('div_date_repeat', checked)"
            :text="'Evènement répété'"
          />
          <div
            id="div_date_repeat"
            class="flex flex-col space-y-2 bg-white p-2 shadow-las rounded-[10px] hidden"
          >
            <div class="flex flex-row space-x-2">
              <FormInput :type="'number'" :text="'0'" />
              <FormDropSection
                @click="toggleDropdown(3)"
                @close="toggleDropdown(3)"
                :section-title="'semaines'"
                :section-is-on="dropdowns[3].isOn"
              />
              <!-- Insérer liste de choix -->
            </div>
            <div class="flex flex-row space-x-2">
              <span>Jusqu'au</span>
              <FormInput :type="'date'" />
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
